%show_ranking.

rank(R) :-
  retractall(ranking(_)),
  retractall(undominated(_)),
  write_ranking(R),
  rank2(R).

rank2([H|T]) :-
  list(H),
  dominators(H),
  assert(ranking(T)).

rank2(R) :-
  assert(ranking(R)).

dominators([H|T]) :-
  assert(undominated(H)),
  dominators(T).

dominators([]).

write_ranking(R) :-
  show_ranking,
  write('Ranking:'),nl,
  write_ranking2(R).

write_ranking(_).

write_ranking2([H|R]) :-
  list(H),!,
  write('  Inviolable: '),
  write_list(H),nl,
  write('  '),write_list(R),nl.

write_ranking2(R) :-
  write('  '),
  write_list(R),nl.

write_list([H|T]) :-
  write(H),write(' '),
  write_list(T).

write_list([]).
  

verbosity(N) :-
  retractall(verbosity_level(_)),
  assert(verbosity_level(N)).

message(parse_noranking,_) :-
  write('No ranking, enter rank with r'),nl.

message(curr_cand,Candidate) :- 
  progress_report(Candidate),
  verbosity_level(N),
  N>0,!,
  write('Developing: '),
  writeres([Candidate]).

/*
message(init_cand,[Input,Candidates]) :- 
  verbosity_level(N),
  N>0,!,
  write('Initial Input: '),write(Input),nl,
  write('Initial Candidates: '),nl,
  writeres(Candidates),nl.

message(final_output,Configs) :-
  write('Final Output: '),nl,
  writeres(Configs),nl.

message(init_pool,Configs) :-
  verbosity_level(2),!,
  write('Initial Candidates: '),nl,
  writeres(Configs),nl.
*/

message(worse_score,[Cand,Stand]) :-
  verbosity_level(2),!,
  write('Discarding: '),writeres([Cand]).

message(accepting, Cand) :-
  verbosity_level(V),
  V > 0,!,
  write('Accepting: '),writeres([Cand]).

message(final_output,Cand) :- !,
  space_after_deriv,
  write('An Output: '),writeout([Cand]).

message(alldone,[]) :- !,
  nl.

message(_,_).

space_after_deriv :-
  verbosity_level(V),
  V > 0,!,
  nl.

space_after_deriv.

%%   Interactive Continutation.  For Windows, defined in bfwin.pro
%%
/*
continue :-
  verbosity_level(N),
  N>0,!,
  write('Continue (y/n)? '),
  get(C),
  continue(C).
*/

% continue.

/*
continue(121) :- !.

continue(_) :-
  write('Generation Aborted'),nl,nl,
  fail.  
*/

writeres([]) :- !.
writeres([res(I,N,Out,Score)|Rest]) :-
  writeres(I,N,Out,Score),nl,
  writeres(Rest).
writeres(I,N,Out,Score) :-
  typography(Out,Out2),
  write(Out2),write('...'),write(I),write(' / '),
  write(N),write(' / '), write(Score).

writeout([]) :- !.
writeout([res(_,_,Out,Score)|Rest]) :-
  writeout(Out,Score),
  writeout(Rest).
writeout(Out,Score) :-
  typography(Out,Out2),
  write(' '),
  write(Out2),nl,
  write('  Marks: '),
  ranking(Ranking),
  writescore(Ranking,Score),nl.

writescore([],[]) :- !.
writescore([Mark|RestRank],[Score|RestScore]) :-
  writescore2(Mark,Score),
  writescore(RestRank,RestScore).

writescore2(_,0) :- !.
writescore2(M,S) :-
 write(' '),write(M),write('/'),write(S).
