#pragma hdrstop
#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\dialog.h>
#include "ftedit.h"



DEFINE_RESPONSE_TABLE1(FTEdit,TEdit)
  EV_WM_RBUTTONDOWN,
END_RESPONSE_TABLE;

const unsigned FTEdit::EditTextLen = 1000;

void FTEdit::EvRButtonDown(UINT U, TPoint &point)
{
	 // point parameter has to be re-packed as an lParam
	 Parent->PostMessage(WM_RBUTTONDOWN,U,
		MAKELONG((WORD)point.x,(WORD) point.y));
}


FTEdit::FTEdit(TWindow *parent, int Id, char *DefExt, char *Filter)
 : TEdit(parent, Id)
{
  FileData.SetFilter(Filter);
  FileData.DefExt=DefExt;
}

void
FTEdit::SaveText()
{
  if (TFileSaveDialog(GetApplication()->MainWindow, FileData).Execute() == IDOK) {
	 ofstream    ofs(FileData.FileName, ios::out|ios::binary);
	 unsigned    maxLen = EditTextLen;
	 char far*   buffer = LockBuffer();
	 unsigned    size = min(maxLen, strlen(buffer));

	 for (unsigned i = 0; i < size && buffer[i]; i++)
		ofs.put(buffer[i]);
	 UnlockBuffer(buffer);
  }
}

/*
void FTEdit::LoadText()
{
  if (IsModified())
	 SaveText();
  RestoreText();
  ClearModified():
}
*/

void FTEdit::RestoreText()
{
  if (TFileOpenDialog(GetApplication()->MainWindow, FileData).Execute() == IDOK) {
	 Clear();

	 ifstream    ifs(FileData.FileName);
	 char far*   buffer = LockBuffer(EditTextLen + 1);

	 for (unsigned i = 0; i < EditTextLen && !ifs.eof(); i++) {
		buffer[i] = (char)ifs.get();
		if (buffer[i] == '\n' && ifs.peek() != '\r') {
		  buffer[i] = '\r';
		  buffer[++i] = '\n';
		}
	 }
	 if (i)
		buffer[i-1] = 0;
	 UnlockBuffer(buffer, TRUE);
  //NotifyParent(CN_UPDATE);
  }
}

