#include <owl\applicat.h>
#include <owl\decframe.h>
#include <owl\messageb.h>
#include <owl\dialog.h>
#include <owl\edit.h>
#include <owl\opensave.h>
#include <owl\button.h>
#include <owl\menu.h>
#include <owl\controlb.h>
#include <owl\buttonga.h>
#include <owl\textgadg.h>
#include <fstream.h>
#include <strstream.h>
#include <string.h>
#include <stdio.h>
#include "strings.h"
#include "amzi.hpp"
#include "ftedit.h"
//#include "l:\amzi\lsvtools.h"

#pragma hdrstop
#include "otw.rc"


//#include <stdarg.h>

// The next two predicates convert "ons fill | nocod parse"
//  to "[[ons,fill],nocod,parse]", etc.

void  Commas(String &inbuf, String &outbuf)
{
  int more = inbuf.SkipSpace().HasMore();
  while (more) {
	 outbuf.GrabGraph(inbuf);
		 more = inbuf.SkipSpace().HasMore();
	 if (more) outbuf<<',';
  }
}

void  CommasQ(String &inbuf, String &outbuf)
{
  int more = inbuf.SkipSpace().HasMore();
  while (more) {
	 outbuf<<'\'';
	 outbuf.GrabGraph(inbuf);
	 outbuf<<'\'';
	 more = inbuf.SkipSpace().HasMore();
	 if (more) outbuf<<',';
  }
}

void StringRanking(String &inbuf,String &outbuf)
{
  outbuf<<"rank([";
  String midbuf(outbuf.length);
  midbuf.GrabTil(inbuf,"|");
  if (inbuf.Peek()=='|') {
	 outbuf<<'[';
	 midbuf.Reset();
	 inbuf.Skip("|");
	 Commas(midbuf,outbuf);
	 outbuf<<"],";
	 Commas(inbuf,outbuf);
  }
  else {
	 midbuf.Reset();
	 Commas(midbuf,outbuf);
  }
  outbuf<<"])";
}

void StringParse(String &inbuf,String &outbuf)
{
  outbuf<<"parse([",
  CommasQ(inbuf,outbuf);
  outbuf<<"])";
}

void DoubleBackSlash(String &input, String &output)
{

  while (input.SkipSpace().HasMore()) {
    output.GrabTil(input, "\\");
    if (input.Peek()=='\\') {
      output << "\\\\";
		input.Skip(1);
    }
  }
}

// For getting info out of the input dialog box
struct TTransferBuffer
{
  char name[81];
};

// TTransferBuffer transferBuffer;

class TApp : public TApplication {
  public:
	 TApp() : TApplication(){}
	 void InitMainWindow();
};


class InptDlg : public TDialog {
  public:
	 InptDlg(TWindow *parent, TResId resId);
	 void SetupWindow();
	 void SetText(const char *);
	 void CmOk();
	 TTransferBuffer transferBuffer;

  protected:
	 void EvSize(UINT sizeType, TSize &size);

  private:
	 TEdit *edit;
	 TButton *parse;
	 TRect windowRect;
	 int buttonWidth;
	 int windowHeight;

  DECLARE_RESPONSE_TABLE(InptDlg);
};

DEFINE_RESPONSE_TABLE1(InptDlg,TDialog)
  EV_COMMAND(IDOK,CmOk),
  EV_WM_SIZE,
END_RESPONSE_TABLE;

class RankDlg : public TDialog {
  public:
	 RankDlg(TWindow *parent, TResId resId);
	 void SetupWindow();
	 void SetText(const char *);

	 FTEdit* edit;
	 BOOL NewRanking;

  protected:
	void EvSize(UINT, TSize &);
	void EvRButtonDown(UINT,TPoint &);
	void CmSave();
	void CmLoad();
	void CmWipe();
	void CmCopy()  {edit->Copy();}
	void CmPaste() {edit->Paste();}
	void CmDelete(){edit->Cut();}

  private:
	 int buttonWidth;
	 int buttonY; // Y displacement
	 int editGapX, editGapY; // dlg - edit

  DECLARE_RESPONSE_TABLE(RankDlg);
};

DEFINE_RESPONSE_TABLE1(RankDlg,TDialog)
  EV_WM_SIZE,
  EV_WM_RBUTTONDOWN,
  EV_COMMAND(CM_RANKSAVE,CmSave),
  EV_COMMAND(CM_RANKLOAD,CmLoad),
  EV_COMMAND(CM_WIPE,CmWipe),
  EV_COMMAND(CM_RANKCOPY,CmCopy),
  EV_COMMAND(CM_RANKPASTE,CmPaste),
  EV_COMMAND(CM_RANKDELETE,CmDelete),
END_RESPONSE_TABLE;

TEdit *output;
char outbuf[102];
int outptr = 0;

void flushout()
{
  outbuf[outptr]='\0';
  output->Insert(outbuf);
  outptr=0;
}

void stickout(int c)
{
  if (c == 10) {
	 outbuf[outptr] = '\r';
	 outbuf[outptr+1] = '\n';
	 outptr+=2;
	 flushout();
	 return;
  }
  if (outptr>100)
	 flushout();
  outbuf[outptr]=c;
  outptr++;
}


void spitc(int c, FILE *)
{
  stickout(c);
}

void spits(char *s)
{
	while (*s != '\0') {
	  stickout(*s);
	  s++;
	}
}

class WindowStatus {
  public:
	 void Get(TWindow *);
	 void Set(TWindow *);
	 void Write(char *,ostream &);
	 void Read(char *,istream &);

  protected:
	 UINT ShowFlag;
	 TRect rect;
};

void WindowStatus::Get(TWindow *window)
{
  if (window->IsIconic()) ShowFlag = SW_MINIMIZE;
  else  ShowFlag = SW_NORMAL;
  window->GetWindowRect(rect);
}

void WindowStatus::Set(TWindow *window)
{
  if (ShowFlag == SW_MINIMIZE)
	 window->Show(SW_MINIMIZE);
  else {
    window->Show(SW_HIDE);
	 window->SetWindowPos(0,rect,SWP_NOZORDER);
	 window->Show(SW_RESTORE);
  }
}

void WindowStatus::Write(char *label, ostream &out)
{
  out<<label<<": "<<ShowFlag<<' '<<rect.left<<' '<<rect.top<<' '
	 <<rect.right<<' '<<rect.bottom<<'\n';
}

void WindowStatus::Read(char buf[],istream &in)
{
  in>>buf>>ShowFlag>>rect.left>>rect.top>>rect.right>>rect.bottom;
}

class TWndw : public TDecoratedFrame {
  public:
	  TWndw(TWindow *parent, const char far *title, TEdit *display);
	  void SetupWindow();
	  BOOL CanClose();
	  friend TF pWinInputProcessed(ENGid);
	  friend TF pContinue(ENGid);
     TF Continue();

  protected:
	 TMenu *menu;
	 InptDlg *input;
	 RankDlg *ranking;
	 TMessageBar *msgbar;
	 TControlBar *cntrlbar;
	 TButtonGadget *parse, *abort, *contin, *runon;
	 TSeparatorGadget *s1, *s2, *s3;
	 TTextGadget *progtext;

  //	 GenDlg *gendlg;

	 BOOL InitCp(char *engine, char *generator);
	 BOOL PrologClean;
	 LRESULT PmIdOk(WPARAM, LPARAM);
	 void CmGST();
	 void CmBSST();
	 void CmLardil();
	 void CmGenerators();
	 void CmCustom();
	 void CmParallel();
	 void CmBestFirst();
	 void CmDemo();
	 void CmHelp();
	 void CmParse();
	 void CmAbort();
	 void CmContinue();
	 void CmRunon();

	 void CmProgressReporting();
	 void CmOutputInput();
	 void CmOutputRanking();
	 void CmOutputDerivation();
	 void CmOutputPause();
	 void CmOutputLosers();
	 void CmOutputSave();
	 void CmOutputWipe();
	 void CmInspect();
	 void SetVerbosity();

	 void CheckMenuItem(UINT item, BOOL value);
	 void GenMenItems(BOOL gstgen, BOOL bsstgen, BOOL lcigen, BOOL cusgen);
	 void EngMenItems(BOOL bfgeng, BOOL pareng, BOOL cuseng);

	 void SetMenuFlag(BOOL &flag, BOOL value, UINT item);
	 BOOL progressreporting, outputinput, outputranking, outputderivation,
		 outputpause, outputlosers;
	 BOOL outputsave;
	 BOOL bfgeng,pareng,cuseng;
	 BOOL gstgen,bsstgen,lcigen,cusgen;

	 BOOL abort_derivation, next_step, run_on;

	 void CmMenuEnable(TCommandEnabler &);
	 BOOL menu_enabled;

	 CLSEngine *cpeng;

	 char generator[120], engine[120];
	 TOpenSaveDialog::TData  FileData;      // save/restore info.

	 void WritePlacement(ofstream &);
	 void ReadPlacement(ifstream &);

	 DECLARE_RESPONSE_TABLE(TWndw);
};

DEFINE_RESPONSE_TABLE1(TWndw, TDecoratedFrame)
  EV_MESSAGE(PM_IDPARSE,PmIdOk),
  EV_COMMAND_ENABLE(CM_EXIT,CmMenuEnable),
  EV_COMMAND(CM_PARSE,CmParse),
  EV_COMMAND(CM_ABORT,CmAbort),
  EV_COMMAND(CM_CONTINUE,CmContinue),
  EV_COMMAND(CM_RUNON,CmRunon),
  EV_COMMAND(CM_GST,CmGST),
  EV_COMMAND_ENABLE(CM_GST,CmMenuEnable),
  EV_COMMAND(CM_BSST,CmBSST),
  EV_COMMAND_ENABLE(CM_BSST,CmMenuEnable),
  EV_COMMAND(CM_LARDIL,CmLardil),
  EV_COMMAND_ENABLE(CM_LARDIL,CmMenuEnable),
  EV_COMMAND(CM_GENERATORS,CmGenerators),
  EV_COMMAND_ENABLE(CM_GENERATORS,CmMenuEnable),
  EV_COMMAND(CM_INSPECT,CmInspect),
  EV_COMMAND(CM_BESTFIRST,CmBestFirst),
  EV_COMMAND_ENABLE(CM_BESTFIRST,CmMenuEnable),
  EV_COMMAND(CM_PARALLEL,CmParallel),
  EV_COMMAND_ENABLE(CM_PARALLEL,CmMenuEnable),
  EV_COMMAND(CM_CUSTOM,CmCustom),
  EV_COMMAND_ENABLE(CM_CUSTOM,CmMenuEnable),
  EV_COMMAND(CM_DEMO,CmDemo),
//  EV_COMMAND_ENABLE(CM_DEMO,CmMenuEnable),  // doesn't work, dunno why
  EV_COMMAND(CM_HELP,CmHelp),
  EV_COMMAND(CM_PROGRESSREPORTING,CmProgressReporting),
  EV_COMMAND(CM_OUTPUTINPUT,CmOutputInput),
  EV_COMMAND(CM_OUTPUTRANKING,CmOutputRanking),
  EV_COMMAND_ENABLE(CM_OUTPUTRANKING,CmMenuEnable),
  EV_COMMAND(CM_OUTPUTDERIVATION,CmOutputDerivation),
  EV_COMMAND_ENABLE(CM_OUTPUTDERIVATION,CmMenuEnable),
  EV_COMMAND(CM_OUTPUTPAUSE,CmOutputPause),
  EV_COMMAND_ENABLE(CM_OUTPUTPAUSE,CmMenuEnable),
  EV_COMMAND(CM_OUTPUTLOSERS,CmOutputLosers),
  EV_COMMAND_ENABLE(CM_OUTPUTLOSERS,CmMenuEnable),
  EV_COMMAND(CM_SAVE_OUTPUT,CmOutputSave),
  EV_COMMAND(CM_WIPE_OUTPUT,CmOutputWipe),
END_RESPONSE_TABLE;

TWndw *theWindow;

TF pContinue(ENGid eid)
{
  TF tf = theWindow->Continue();

  return tf;
}

TF TWndw::Continue()
{
  if (abort_derivation)
	 return FALSE;
  if (outputderivation) {
	 next_step = FALSE;
	 while (!next_step && !run_on) {
		GetApplication()->PumpWaitingMessages();
		if (abort_derivation)
		  return FALSE;
	 }
  }

  return TRUE;
}

TF pWinInputProcessed(ENGid eid)
{
  int i,length;
  char buf[120];
  char buf2[120] = "progress: ";

  lsGetParm(eid,1,cINT,&length);
  for (i=0; i<length; i++) {
	 buf[i]='*';
  }
  buf[length]='\0';
  strcat(buf2,buf),
  theWindow->progtext->SetText(buf2);

  return TRUE;
}

PRED_INIT arrayPreds[] =
	 {
		{"win_input_processed",1, pWinInputProcessed},
		{"continue",0,pContinue},
		{NULL,0,NULL}
};

void TWndw::WritePlacement(ofstream &ofile)
{
  WindowStatus status;
  char buf[120];

  status.Get(this);
  status.Write("main:",ofile);

  status.Get(ranking);
  status.Write("ranking:",ofile);

  status.Get(input);
  status.Write("input:",ofile);

  ofile.close();
}

void TWndw::ReadPlacement(ifstream &ifile)
{
  WindowStatus status;
  char buf[120];

  status.Read(buf, ifile);
  status.Set(this);

  status.Read(buf, ifile);
  status.Set(ranking);

  status.Read(buf, ifile);
  status.Set(input);

  ifile.close();
}


TWndw::TWndw(TWindow *parent, const char far *title, TEdit *display) :
  TDecoratedFrame(parent, title, display,TRUE)
{

  AssignMenu(MENU_1);
  Attr.X = 250;
  Attr.Y = 150;
  Attr.W = 500;
  Attr.H = 400;

  theWindow = this;

  cntrlbar = new TControlBar(this);

  parse = new TButtonGadget(BMP_PARSE,CM_PARSE);
  progtext = new TTextGadget(0,TGadget::Recessed,TTextGadget::Left,30);
  s1 = new TSeparatorGadget();
  s2 = new TSeparatorGadget();
  s3 = new TSeparatorGadget();
  abort = new TButtonGadget(BMP_ABORT,CM_ABORT);
  abort->SetEnabled(TRUE);
  contin = new TButtonGadget(BMP_CONTINUE,CM_CONTINUE);
  contin->SetEnabled(TRUE);
  runon = new TButtonGadget(BMP_RUNON,CM_RUNON);
  runon->SetEnabled(TRUE);

  cntrlbar->Insert(*parse);

  cntrlbar->SetHintMode(TControlBar::EnterHints);
  Insert(*cntrlbar);

  msgbar = new TMessageBar(this);
  msgbar->SetText("Welcome to OTW, ready for Galilean Syllable Theory");
  Insert(*msgbar,TDecoratedFrame::Bottom);

  input = new InptDlg(this, INPUTDLG);
  input->transferBuffer.name[0]='\0';

  ranking = new RankDlg(this, RANKINGDLG);
//  gendlg = new GenDlg(this,GENDLG);


  strcpy(engine,"bfg.xpl");
  strcpy(generator,"gst.pro");

  output = display;

  FileData.SetFilter("Text File (*.txt)|*.txt|All Files (*.*)|*.*|");
  FileData.DefExt="txt";

}

void TWndw::GenMenItems(BOOL gst, BOOL bsst, BOOL lci, BOOL custom)
{
	 SetMenuFlag(gstgen,gst,CM_GST);
	 SetMenuFlag(bsstgen,bsst,CM_BSST);
	 SetMenuFlag(lcigen,lci,CM_LARDIL);
	 SetMenuFlag(cusgen,custom,CM_GENERATORS);
}

void TWndw::EngMenItems(BOOL bfg, BOOL par, BOOL cus)
{
	 bfgeng = bfg;
	 CheckMenuItem(CM_BESTFIRST,bfgeng);
	 pareng = par;
	 CheckMenuItem(CM_PARALLEL,pareng);
	 cuseng = cus;
	 CheckMenuItem(CM_CUSTOM,cuseng);
}

BOOL TWndw::CanClose()
{
	if (!menu_enabled)  // don't shut down in the middle of a parse!!
	  return FALSE;

	cpeng->Close();

	if (IsZoomed())
	  Show(SW_RESTORE);

	ofstream ofile("otw.ini");
	ofile << "otw1.0 ";
	WritePlacement(ofile);
	TFrameWindow::CanClose();

	return TRUE;
}

void TWndw::SetupWindow()
{
	 char buf[120];

	 TWindow::SetupWindow();

	 menu = new TMenu(HWindow);

	 SetMenuFlag(progressreporting,TRUE,CM_PROGRESSREPORTING);
	 SetMenuFlag(outputinput,TRUE,CM_OUTPUTINPUT);
	 SetMenuFlag(outputranking,FALSE,CM_OUTPUTRANKING);
	 SetMenuFlag(outputderivation,FALSE,CM_OUTPUTDERIVATION);
	 SetMenuFlag(outputpause,FALSE,CM_OUTPUTPAUSE);
	 SetMenuFlag(outputlosers,FALSE,CM_OUTPUTLOSERS);

	 EngMenItems(TRUE, FALSE, FALSE);
	 GenMenItems(TRUE,FALSE,FALSE,FALSE);

	 menu_enabled = TRUE;

	 input->Create();
	 ranking->Create();

	 ifstream initfile("otw.ini");

	 if (initfile) {
		initfile >> buf;
		if (!strcmp(buf,"otw1.0"))
		  ReadPlacement(initfile);
	 }
	input->Show(SW_SHOW);
	ranking->Show(SW_SHOW);
	SetActiveWindow();

	//	 cpeng = new CPEngine;
	 if (!InitCp(engine,generator)) return;
	 output->SetReadOnly(TRUE);
}

void TWndw::CmMenuEnable(TCommandEnabler &enabler)
{
  enabler.Enable(menu_enabled);
}

BOOL TWndw::InitCp(char *engine, char *generator)
{
	char buf[120];
	char errmsg[80];
	RC rc;
	TF tf;

	 if ((cpeng = new CLSEngine) == NULL) {
		MessageBox("couldn't start CP Engine","startup problem");
		return FALSE;
	 }
	if (rc = cpeng->Init("otp")) {
		cpeng->ErrMsg(errmsg);
		sprintf(buf,"Prolog initialization error: %d\n%s", rc, errmsg);
		MessageBox(buf, "OTW says", MB_OK);
		return FALSE; }

	if (rc = cpeng->InitPreds(arrayPreds)) {
		cpeng->ErrMsg(errmsg);
		sprintf(buf,"Pred initialization error: %d\n%s", rc, errmsg);
		MessageBox(buf, "OTW says", MB_OK);
		return FALSE; }

	if (rc = cpeng->Load(engine)) {
		cpeng->ErrMsg(errmsg);
		sprintf(buf,"Engine loading error: %d\n%s", rc, errmsg);
		MessageBox(buf, "OTW says", MB_OK);
		return FALSE; }

	 TERM t;
	  sprintf(buf,"consult('%s')",generator);
	  String ingen(buf);
	  String outgen(120);
	  DoubleBackSlash(ingen,outgen);
	  cpeng->StrToTerm(&t,outgen.buf);
	  tf = cpeng->Exec(&t);
	  if (!tf) {
		 cpeng->ErrMsg(errmsg);
		 sprintf(buf,"Generator Loading Error: %d\n%s", rc,errmsg);
		 MessageBox(buf,"OTW says",MB_OK);
		 return FALSE;
	  }

	 cpeng->SetStream(CUR_OUT,3);
	 cpeng->SetStream(USER_OUT,3);
	 cpeng->SetOutput((void (*)())spitc,(void (*)())spits);

	 SetVerbosity();
	 PrologClean = TRUE;
	 ranking->NewRanking = TRUE;
	 return TRUE;

}

void TWndw::CmParse()
{
  input->CmOk();
}

void TWndw::CmAbort()
{
	abort_derivation = TRUE;
}


void TWndw::CmContinue()
{
  next_step = TRUE;
}


void TWndw::CmRunon()
{
  run_on = TRUE;
}

LRESULT TWndw::PmIdOk(WPARAM,LPARAM)
{

  char buf[120];
  char errmsg[80] ;
  TERM t;
  RC rc;
  TF tf;
  BOOL ok;

  if (!menu_enabled)  // if in the middle of a parse, do nothing
	 return 1;

  if (!PrologClean)  {
	 cpeng->Close();
	 ok = InitCp(engine,generator);
	 if (!ok) {
//		MessageBox("Some Problem with the Prolog","OTW says");
		return 1;
	 }
  }

  if (PrologClean) {
	 String termstring(1500);
	 if (ranking->edit->IsModified())
		 ranking->NewRanking = TRUE;
	 if (ranking->NewRanking) {
		char *rankbuf = ranking->edit->LockBuffer();
		String rankstring(strlen(rankbuf));
		strcpy(rankstring.buf,rankbuf);
		ranking->edit->UnlockBuffer(rankbuf);
		StringRanking(rankstring,termstring);
		if (!strcmp(termstring.buf,"rank([])")) {
		  MessageBox("No Ranking","OTW says");
		  return 1;
		}
		rc = cpeng->StrToTerm(&t,termstring.buf);
		if (rc) {
		  cpeng->ErrMsg(errmsg);
		  sprintf(buf,"Problem Reading Ranking: %d\n%s", rc,errmsg);
		  MessageBox(buf,"OTW says");
		  return 1;
		}
		cpeng->Exec(&t);
		ranking->NewRanking = FALSE;
		ranking->edit->ClearModify();
	 }
	 String inputstring(input->transferBuffer.name);
	 termstring.Reset();

//cursor at end of buffer
	 char far*   buffer = output->LockBuffer();
	 unsigned    size = strlen(buffer);
	 output->UnlockBuffer(buffer);
	 output->SetSelection(size,size);

//Set Progress Reporting:
	if (progressreporting)
	  cpeng->StrToTerm(&t,"assert(progressreporting)");
	else
	  cpeng->StrToTerm(&t,"retractall(progressreporting)");
	cpeng->Exec(&t);

//set continue flags
	abort_derivation = FALSE;
	run_on = !outputpause;
		 
//write input, if this is supposed to happen
	 if (outputinput)
		{
		  char inbuf[120];
		  sprintf(inbuf, "Input: %s\r\n", inputstring.buf);
		  output->Insert(inbuf);
		}
	 StringParse(inputstring,termstring);
	 rc = cpeng->StrToTerm(&t, termstring.buf);
	 if (rc) {
		cpeng->ErrMsg(errmsg);
		sprintf(buf,"Problem reading input: %d\n%s", rc,errmsg);
		MessageBox(buf,"OTW says");
		return 1;
	 }

	 cntrlbar->Remove(*parse);
	 if (outputpause) {
		cntrlbar->Insert(*contin);
		cntrlbar->Insert(*s2);
		cntrlbar->Insert(*runon);
 		cntrlbar->Insert(*s1);
	 }
	 cntrlbar->Insert(*abort);

	 if (progressreporting) {
		cntrlbar->Insert(*s3);
		cntrlbar->Insert(*progtext,TGadgetWindow::After,s3);
	 }
	 cntrlbar->Invalidate();
	 cntrlbar->LayoutSession();

	 msgbar->SetHintText("processing");

// disable lots of menu items
	 menu_enabled = FALSE;

// do the work, at last!
	 tf = cpeng->Exec(&t);

// Restore menus, toolbar, etc.
	 menu_enabled = TRUE;

	 if (progressreporting) {
		cntrlbar->Remove(*s3);
		cntrlbar->Remove(*progtext);
	 }
	 if (outputpause) {
		cntrlbar->Remove(*contin);
		cntrlbar->Remove(*s1);
		cntrlbar->Remove(*runon);
		cntrlbar->Remove(*s2);
	 }
	 cntrlbar->Remove(*abort);
	 cntrlbar->Insert(*parse);
	 cntrlbar->LayoutSession();
	 cntrlbar->Invalidate();

	 if (tf == TRUE) {
		if (abort_derivation)
		  msgbar->SetHintText("Processing Aborted");
		else
		  msgbar->SetHintText("Processing Completed");
	 }
	 else {
		cpeng->ErrMsg(errmsg);
		sprintf(buf,"Problem parsing input: %d\n %s",tf,errmsg);
		MessageBox(buf,"OTW says");
		PrologClean = FALSE;
	 }
	 flushout();

	 return 1;
  }
  else return 0;
}

void TWndw::CmGST()
{
  strcpy(generator,"gst.pro");
  PrologClean = FALSE;
  GenMenItems(TRUE,FALSE,FALSE,FALSE);
  msgbar->SetText("Generator is now Galilean Syllable Theory");
}

void TWndw::CmBSST()
{
  strcpy(generator,"bsst.pro");
  PrologClean = FALSE;
  GenMenItems(FALSE,TRUE,FALSE,FALSE);
  msgbar->SetText("Generator is now Basic Syllable Structure Theory");
}

void TWndw::CmLardil()
{
  strcpy(generator,"lardil.pro");
  PrologClean = FALSE;
  GenMenItems(FALSE,FALSE,TRUE,FALSE);
  msgbar->SetText("Generator is now Lardil Constraint Interaction");
}

void TWndw::CmGenerators()
{
  char buf[30];

  TOpenSaveDialog::TData fileData(OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST,
	 "Prolog (*.pro)|*.pro|Compiled Amzi (*.plm)|*.plm|All Files (*.*)|*.*}");
  if (TFileOpenDialog(this,fileData,0,"OT Generators to Load").Execute()==IDOK) {
	  strcpy(generator,fileData.FileName);
	  PrologClean = FALSE;
	  GenMenItems(FALSE,FALSE,TRUE,TRUE);
  }
  sprintf(buf,"Generator is now %s",generator);
  msgbar->SetText(buf);
}

/*
void TWndw::CmInspect()
{
  if (gendlg->IsWindowVisible())
	 gendlg->BringWindowToTop();
  else {
	 gendlg->Create();
	 gendlg->Show(SW_SHOW);
  }
}
*/

void TWndw::CmInspect()
{
	char buf[120];
	sprintf(buf,"notepad.exe %s",generator);
	WinExec(buf,SW_SHOWNORMAL);
}

void TWndw::CmBestFirst()
{
	strcpy(engine,"bfg.xpl");
	PrologClean = FALSE;
	EngMenItems(TRUE, FALSE,FALSE);
	msgbar->SetText("Engine is now Best First");
}

void TWndw::CmParallel()
{
	strcpy(engine,"par.xpl");
	PrologClean = FALSE;
	EngMenItems(FALSE,TRUE,FALSE);
	msgbar->SetText("Engine is now Paralell");
}

void TWndw::CmCustom()
{
  char buf[30];

  TOpenSaveDialog::TData fileData(OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST,
	 "Linked Amzi! (*.xpl)|*.xpl");
  if (TFileOpenDialog(this,fileData,0,"OTW Engines to Load").Execute()==IDOK) {
	  strcpy(engine,fileData.FileName);
	  PrologClean = FALSE;
	  EngMenItems(FALSE, FALSE, TRUE);
	  sprintf(buf,"Engine is now %s",engine);
	  msgbar->SetText(buf);
  }
}

void TWndw::CheckMenuItem(UINT item, BOOL value)
{
	if (value)
	  menu->CheckMenuItem(item,MF_CHECKED);
	else
	  menu->CheckMenuItem(item,MF_UNCHECKED);
}

void TWndw::SetMenuFlag(BOOL &flag, BOOL value, UINT item)
{
  flag = value;
  CheckMenuItem(item,value);
}

void TWndw::CmProgressReporting()
{
	SetMenuFlag(progressreporting,!progressreporting,
		CM_PROGRESSREPORTING);
}

void TWndw::CmOutputInput()
{
	SetMenuFlag(outputinput,!outputinput,CM_OUTPUTINPUT);
}

void TWndw::CmOutputRanking()
{
  char buf[30];
  TERM t;

  SetMenuFlag(outputranking,!outputranking,CM_OUTPUTRANKING);

  if (outputranking)
	 strcpy(buf,"assert(show_ranking)");
  else
	 strcpy(buf,"retractall(show_ranking)");

  cpeng->StrToTerm(&t,buf);
  cpeng->Exec(&t);

}


void TWndw::CmOutputDerivation()
{
  SetMenuFlag(outputderivation,!outputderivation,CM_OUTPUTDERIVATION);
  if (!outputderivation) {
	 SetMenuFlag(outputlosers,FALSE,CM_OUTPUTLOSERS);
	 SetMenuFlag(outputpause,FALSE,CM_OUTPUTPAUSE);
  }
  SetVerbosity();
}

void TWndw::CmOutputPause()
{
  SetMenuFlag(outputpause,!outputpause,CM_OUTPUTPAUSE);
  if (outputpause) {
	 SetMenuFlag(outputderivation,TRUE,CM_OUTPUTDERIVATION);
	 SetVerbosity();
  }
}

void  TWndw::CmOutputLosers()
{
  SetMenuFlag(outputlosers,!outputlosers,CM_OUTPUTLOSERS);

  if (outputlosers)
	 SetMenuFlag(outputderivation,TRUE,CM_OUTPUTDERIVATION);

  SetVerbosity();
}

void TWndw::SetVerbosity()
{
  char buf[40];
  TERM t;
  if (outputlosers)
	 strcpy(buf,"verbosity(2)");
  else if (outputderivation)
	 strcpy(buf,"verbosity(1)");
  else
	 strcpy(buf,"verbosity(0)");

  cpeng->StrToTerm(&t,buf);
  cpeng->Exec(&t);
}

void TWndw::CmOutputSave()
{
  if (TFileSaveDialog(GetApplication()->MainWindow, FileData).Execute() == IDOK) {
	 ofstream    ofs(FileData.FileName, ios::out|ios::binary);
//	 unsigned    maxLen = EditTextLen;
	 char far*   buffer = output->LockBuffer();
	 unsigned    size = strlen(buffer);

	 for (unsigned i = 0; i < size && buffer[i]; i++)
		ofs.put(buffer[i]);
	 output->UnlockBuffer(buffer);
  }
}

void TWndw::CmOutputWipe()
{
  output->SetReadOnly(FALSE);
  output->Clear();
  output->SetReadOnly(TRUE);
}

void TWndw::CmDemo()
{
  input->SetText("a b");
  ranking->SetText("parse\r\nons\r\nfill\r\nnocod");
  ranking->NewRanking = TRUE;
  msgbar->SetText("Hit Parse in input window; select Generators | Inspect Generator for more info.");
  if (strcmp("gst.pro",generator)) {
	 strcpy(generator,"gst.pro");
	 PrologClean = FALSE;
  }
}

void TWndw::CmHelp()
{
  char buf[100] = "notepad.exe help.txt";
  WinExec(buf,SW_SHOWNORMAL);
}


RankDlg::RankDlg(TWindow *parent, TResId resId) :
  TDialog(parent,resId)
{
  edit = new  FTEdit(this, IDC_EDIT2, "rnk",
		"Rankings (*.rnk)|*.rnk|All Files (*.*)|*.*|");
}

void RankDlg::SetupWindow()
{
  TRect rect, windowRect;

  TDialog::SetupWindow();
  GetWindowRect(rect);
  MoveWindow(30,30,rect.Width(),rect.Height());

  GetWindowRect(windowRect);

  edit->GetWindowRect(rect);
  editGapY=windowRect.Height()-rect.Height();
  editGapX=windowRect.Width()-rect.Width();
}

void RankDlg::EvSize(UINT sizeType, TSize &)
{
  TRect rect, windowRect;
//  char buf[20];

  if (sizeType != SIZE_MINIMIZED) {
	 GetWindowRect(windowRect);

	 rect = edit->GetWindowRect();
	 edit->SetWindowPos(0,0,0,
		windowRect.Width()-editGapX,windowRect.Height()-editGapY,
		SWP_NOZORDER|SWP_NOMOVE);

  }
}

void RankDlg::EvRButtonDown(UINT, TPoint &point)
{

  TMenu menu(HWindow);
  HMENU hMenu = menu.GetSubMenu(1);
  TRect rect;
  GetWindowRect(rect);
  TPopupMenu popupMenu(hMenu);
  popupMenu.TrackPopupMenu(0,point.x+rect.left+20,point.y+rect.top+30,
	 0, HWindow, 0);

}

void RankDlg::CmSave()
{
  edit->SaveText();
}

void RankDlg::CmWipe()
{
  edit->Clear();
  edit->ClearModify();
  NewRanking=TRUE;
}

void RankDlg::CmLoad()
{
  edit->RestoreText();
  edit->ClearModify();
  NewRanking=TRUE;
}

void RankDlg::SetText(const char *text)
{
  edit->Clear();
  edit->SetText(text);
}

InptDlg::InptDlg(TWindow *parent, TResId resId) :
  TDialog(parent,resId)
{
  edit = new TEdit(this, IDC_EDIT1, sizeof(transferBuffer.name));
  parse = new TButton(this, IDOK);
//  abort = new TButton(this, IDCANCEL);
  TransferBuffer = & transferBuffer;
}

void InptDlg::SetupWindow()
{
  TRect parentRect, dlgRect;

  TDialog::SetupWindow();

  Parent->GetWindowRect(parentRect);
  GetWindowRect(dlgRect);

  MoveWindow(250,30,dlgRect.Width(),dlgRect.Height());
  windowRect = GetWindowRect();
  buttonWidth = parse->GetWindowRect().Width();
}

void InptDlg::CmOk()
{
  TransferData(tdGetData);
  Parent -> PostMessage(PM_IDPARSE, 0, 0);
}

void InptDlg::EvSize(UINT sizeType, TSize &)
{

  if (sizeType != SIZE_MINIMIZED) {
	 TRect rect = GetWindowRect();
	 int xChange = rect.Width() - windowRect.Width();

	 windowRect = rect;

  // The edit control
	 rect = edit->GetWindowRect();
	 edit->SetWindowPos(0,0,0,rect.Width()+xChange,rect.Height(),
		SWP_NOZORDER | SWP_NOMOVE);
  }
}

void InptDlg::SetText(const char *text)
{
  edit->Clear();
  edit->SetText(text);
}

void TApp::InitMainWindow()
{

#ifdef __WIN32__
  char name[]="OTW 1.1 (32)";
#else
  char name[]="OTW 1.1 (16)";
#endif
  TDecoratedFrame *wndw = new TWndw(0, name,
	 new TEdit(0,ID_DISPLAY_EDIT, "", 10, 10, 60, 60,0, TRUE));
  SetMainWindow(wndw);
  EnableCtl3d(TRUE);
  EnableBWCC();
}


int OwlMain(int, char*[])
{
 return TApp().Run();
}




