/*
   String handling routines.  The general philosophy is to take pointers to
   pointers to a null-terminated input string and an output buffer, and a
   pointer to the end of the buffer, returning 0 if the output overruns
   the end, otherwise returning a pointer to the last position
   occupied in the buffer, which will be occupied by `\0'.
*/

#include <ctype.h>
#include <string.h>
#include <stdio.h>


class String {

 public:
   char *buf;
   int  length,pos, ok;

   String(int size = 80) { buf = new char[size+1]; length=size; pos=0; ok = 1;}
   String(char *text) { buf = text; length = strlen(text); pos=0; ok = 1;}

   String operator<< (char *text);
   String operator<< (char c);

   void Reset();
   String SkipSpace();
   String Skip(char *stuff);
   String Skip(int i);
   int  GrabGraph(String &source);
   char Peek() {return buf[pos];};
   void GrabTil(String &source, char *til);
   int  HasMore() {if (buf[pos] != '\0') return 1; else return 0;}
};

